{ 2006-11-18 programmeerimisvistlus                                        }
{ lesanne: SIDEKAABLITE REMONT                                             }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 2.0.0 / Win32                                               }

{ Natuke ebaefektiivne lahendus }
{ Kasutab sgavuti lbimist ja hoiab graafi naabrusmaatriksina }

const
   sisf = 'side.sis';                                    { sisendfaili nimi }
   valf = 'side.val';                                   { vljundfaili nimi }
   maxn = 500;                                     { maksimaalne klade arv }

var
   n : integer;                                                { klade arv }
   a : array [1..maxn, 1..maxn] of integer;     { kaableid klast i klla j }

{ kontrollib, kas saab klast s klla t }
function otsi(s, t : integer) : boolean;
var b : array [1..maxn] of boolean;              { kla i on juba tdeldud }
   { leiab sgavuti lbimisega kik klad, kuhu saab klast i }
   procedure tootle(i : integer);
   var j : integer;
   begin
      if b[i] then                                { kui i on juba tdeldud }
         exit;                                 { siis pole enam midagi teha }
      b[i] := true;                                   { nd on i tdeldud }
      for j := 1 to n do
         if a[i, j] > 0 then                            { kui j on i naaber }
            tootle(j);                                  { ttleme selle ka }
   end;
var i : integer;
begin
   for i := 1 to n do
      b[i] := false;
   tootle(s);                       { leiame kik klad, kuhu saab klast s }
   exit(b[t]);                                    { kas saime ka klasse t? }
end;

var
   f : text;
   m : integer;                                              { kaablite arv }
   k : integer;                                  { kriitiliste kaablite arv }
   i, s, t : integer;

begin
   { loeme sisendi }
   assign(f, sisf); reset(f);
   readln(f, n, m);
   for s := 1 to n do
      for t := 1 to n do
         a[s, t] := 0;
   for i := 1 to m do begin
      readln(f, s, t);
      a[s, t] := a[s, t] + 1;
      a[t, s] := a[t, s] + 1;
   end;
   close(f);

   { loendame kriitilised kaablid }
   k := 0;
   for s := 1 to n do
      for t := s + 1 to n do
         if a[s, t] = 1 then begin
            { kui klast s on klasse t tpselt ks kaabel, sulgeme selle }
            a[s, t] := 0;
            a[t, s] := 0;
            if not otsi(s, t) then begin
               { kui prast seda pole vimalik saada klast s klasse t }
               { siis oli see kriitiline kaabel }
               k := k + 1;
            end;
            a[s, t] := 1;
            a[t, s] := 1;
         end;

   { vljastame vastuse }
   assign(f, valf); rewrite(f);
   writeln(f, k);
   close(f);
end.
