/* 2006-11-18 programmeerimisvistlus                                       */
/* lesanne: SIDEKAABLITE REMONT                                            */
/* Autor: Margus Niitsoo                                                    */
/* Testitud: GCC 3.2.3 / MinGW32                                            */

/* Natuke ebaefektiivne lahendus */
/* Kasutab laiuti lbimist ja hoiab graafi naabrusnimistutena */

#include <stdio.h>

int al[1001][1001]; // Naabrusnimistud
int als[1001]; // Naabrusnimistute pikkused
int q[1001]; // Jrjend BFS tarbeks
char noted[1001];

int main()
{
    int n, m;
    int a, b;
    int i, k, l, nd;
    int res=0;
    FILE *in, *out;

    in=fopen("side.sis","rt");
    fscanf(in,"%i %i",&n,&m);

    for(i=0;i<n;i++) als[i]=0;

    for(i=0;i<m;i++)
    {
        fscanf(in,"%i %i",&a,&b);
        a--; b--; // Indeksid 1...n kujult 0...(n-1) kujule
        al[a][als[a]]=b; als[a]++; // Lisa b a naabrusnimistusse
        al[b][als[b]]=a; als[b]++; // Ja vastupidi
    }

    fclose(in);

    for(a=0;a<n;a++)
        for(b=0;b<als[a];b++)
            if(al[a][b]>=a) // Vaatame igat serva vaid htepidi
            {
                // Kontrollime graafi sidusust

                // Mrgime kik tipud mitteklastatuks
                for(i=0;i<n;i++) noted[i]=0;

                // Laiuti otsing ehk BFS
                q[0]=a; noted[a]=1; i=0; k=1;
                while(i<k)
                {
                    nd=q[i];

                    if(nd==al[a][b]) break; // Lpetame, kui leidsime tee a->b

                    for(l=0;l<als[nd];l++)
                        if((nd!=a || l!=b) && // Vlja valitud serva me ei kasuta
                            noted[al[nd][l]]==0)
                        {
                            q[k]=al[nd][l]; noted[q[k]]=1; k=k+1;
                        }

                    i++;
                }

                if(nd!=al[a][b] && i==k) // BFS ei judnud al[a][b]-sse
                res++;
            }

    out=fopen("side.val","wt");
    fprintf(out,"%i\n",res);
    fclose(out);

    return 0;
}
