/* 2006-11-18 programmeerimisvistlus                                       */
/* lesanne: SIDEKAABLITE REMONT                                            */
/* Autor: Margus Niitsoo                                                    */
/* Testitud: GCC 3.2.3 / MinGW32                                            */

/* Efektiivne lahendus */
/* Kasutab sgavuti lbimist ja leiab sillad lbimise aegade jrgi */

#include <stdio.h>

int al[1001][1001]; // Naabrusnimistu
int als[1001]; // Naabrusnimistute pikkused
int visited[1001];
int time, res;

// NB! hetkel otsib liketippe

int dfs(int nd, int prv)
{
    int i,b,t;
    int low;

    visited[nd]=low=b=time; time++;

    for(i=0;i<als[nd];i++)
    {
        if(visited[al[nd][i]]!=0)
        {   
            if(al[nd][i]==prv) prv=-1; // Jtame vahele sisenemisserva
            else b=visited[al[nd][i]];
        }
        else
        {
            t=time;
            b=dfs(al[nd][i],nd);
            if (b==t) res++;
        }

        if (b<low) low=b;
    }

    return low;
}

int main()
{
    int n, m;
    int i, a, b;
    FILE *in, *out;

    in=fopen("side.sis","rt");
    fscanf(in,"%i %i",&n,&m);

    for(i=0;i<n;i++) { als[i]=0; visited[i]=0; }

    for(i=0;i<m;i++)
    {
        fscanf(in,"%i %i",&a,&b);
        a--; b--; // Indeksid 1...n kujult 0...(n-1) kujule
        al[a][als[a]]=b; als[a]++; // Lisa b a naabrusnimistusse
        al[b][als[b]]=a; als[b]++; // Ja vastupidi
    }

    fclose(in);

    time=1; res=0;
    dfs(0,0);

    out=fopen("side.val","wt");
    fprintf(out,"%i\n",res);
    fclose(out);

    return 0;
}
