{ 2006-11-18 programmeerimisvistlus                                        }
{ lesanne: SNASTIK                                                        }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 2.0.0 / Win32                                               }

{ Efektiivne lahendus, kasutab kahendotsingut }

const
   sisf = 'sonad.sis';                                   { sisendfaili nimi }
   valf = 'sonad.val';                                  { vljundfaili nimi }
   maxm = 10000;                             { maksimaalne snastiku suurus }

var
   m : integer;                                          { snastiku suurus }
   a : array [1..maxm] of string;                                { snastik }

{ kontrollib, kas sne s esineb snastikus }
function otsi(s : string) : boolean;
var v, p, k : integer;
begin
   v := 1; p := m;                     { kui s esineb, on ta ligus a[v..p] }
   while v <= p do begin                      { kuni lik pole thi, otsime }
      k := (v + p) div 2;                  { leiame ligu keskmise elemendi }
      if s = a[k] then                         { kui s on keskmisega vrdne }
         exit(true);                                       { siis leidsime! }
      if s > a[k] then                         { kui s on keskmisest suurem }
         v := k + 1;           { siis on ta suurem tervest vasakust poolest }
      if s < a[k] then                        { kui s on keskmisest viksem }
         p := k - 1;          { siis on ta viksem tervest paremast poolest }
   end;
   exit(false);        { kui judsime thja hulgani, siis s snastikus pole }
end;

var
   fsis : text;                                                { sisendfail }
   fval : text;                                               { vljundfail }
   n : integer;                                             { pringute arv }
   s : string;                                             { jooksev pring }
   i : integer;

begin
   assign(fsis, sisf); reset(fsis);
   assign(fval, valf); rewrite(fval);

   { loeme snastiku }
   readln(fsis, m);
   for i := 1 to m do
      readln(fsis, a[i]);

   { loeme ja ttleme pringud }
   readln(fsis, n);
   for i := 1 to n do begin
      readln(fsis, s);
      if otsi(s) then
         writeln(fval, 'JAH')
      else
         writeln(fval, 'EI');
   end;

   close(fsis);
   close(fval);
end.
