{ 2006-11-18 programmeerimisvistlus                                        }
{ lesanne: VAADID                                                          }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 2.0.0 / Win32                                               }

{ Sissemahtumise tingimus vormistatud eraldi funktsioonina                  }

const
   sisf = 'vaadid.sis';                                  { sisendfaili nimi }
   valf = 'vaadid.val';                                 { vljundfaili nimi }
   maxn = 3;                                                  { vaatide arv }

{ kontrollib, kas vaat d1/h1 mahub vaadi d2/h2 sisse }
function mahub(d1, h1, d2, h2 : longint) : boolean;
begin
   if (d1 < d2) and (h1 < h2) then
      exit(true);                                             { mahub psti }
   if (d1 < h2) and (sqr(d1) + sqr(h1) < sqr(d2)) then
      exit(true);                                            { mahub klili }
   exit(false);                                      { ei mahu kumbagi pidi }
end;

var
   f : text;                          { failimuutuja sisendi/vljundi jaoks }
   d, h : array [1..maxn] of integer;        { vaatide lbimdud, krgused }
   i, j : integer;

begin
   { loeme sisendi }
   assign(f, sisf); reset(f);
   for i := 1 to maxn do
      readln(f, d[i], h[i]);
   close(f);

   { teeme vljundi }
   assign(f, valf); rewrite(f);
   for i := 1 to maxn do
      for j := i + 1 to maxn do
         { vaatide i ja j omavahelised suhted }
         if mahub(d[i], h[i], d[j], h[j]) then
            writeln(f, i, '->', j)                     { i mahub j sisse... }
         else if mahub(d[j], h[j], d[i], h[i]) then
            writeln(f, i, '<-', j)                     { j mahub i sisse... }
         else
            writeln(f, i, '--', j);               { ei mahu kumbagi pidi... }
   close(f);
end.
