// 2006-11-18 programmeerimisvistlus
// lesanne: SNASTIK
// Autor: Ahto Truu
// Testitud: GCC 3.2.3 / WinGW32

// Efektiivne lahendus, kasutab C++ standardset kahendotsingut

#include <fstream>
#include <string>
#include <vector>
#include <algorithm>
using namespace std;

ifstream fsis("sonad.sis"); // sisendfail
ofstream fval("sonad.val"); // vljundfail

vector<string> ss; // snastik

int main() {
    int m, n;
    string s;
    // loeme snastiku
    fsis >> m;
    for (int i = 0; i < m; ++i) {
        fsis >> s;
        ss.push_back(s);
    }
    // loeme ja ttleme pringud
    fsis >> n;
    for (int i = 0; i < n; ++i) {
        fsis >> s;
        vector<string>::iterator p = lower_bound(ss.begin(), ss.end(), s);
        if (p != ss.end() && *p == s)
            fval << "JAH" << endl;
        else
            fval << "EI" << endl;
    }
    return 0;
}
