{ 2006-11-18 programmeerimisvistlus                                        }
{ lesanne: SUDOKU                                                          }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 2.0.0 / Win32                                               }

{ Kigi variantide juga lbivaatus                                         }
{ NB! Loeb standardsisendist, kirjutab standardvljundisse                  }

const
   blkr = 3;                                         { bloki krgus ridades }
   blkv = 5;                                        { bloki laius veergudes }
   blkm = blkr * blkv;      { bloki suurus mrkides, ka ridade/veergude arv }
   tmin = 'A'; tmax = 'O';                             { kasutatavad mrgid }
   tuhik = '.';

var
   a : array [1..blkm, 1..blkm] of char;                             { laud }
   vr : array [1..blkm, tmin..tmax] of boolean;      { vabad mrgid ridades }
   vv : array [1..blkm, tmin..tmax] of boolean;             { ... veergudes }
   vb : array [1..blkv, 1..blkr, tmin..tmax] of boolean;    { ... blokkides }

{ kas kohale [r,v] vib panna mrgi m }
function vaba(r, v : integer; m : char) : boolean;
begin
   vaba := vr[r, m] and vv[v, m] and
      vb[(r - 1) div blkr + 1, (v - 1) div blkv + 1, m];
end;

{ paneb mrgi m kohale [r,v] }
procedure pane(r, v : integer; m : char);
begin
   a[r, v] := m;
   vr[r, m] := false;
   vv[v, m] := false;
   vb[(r - 1) div blkr + 1, (v - 1) div blkv + 1, m] := false;
end;

{ eemaldab mrgi m kohalt [r,v] }
procedure vota(r, v : integer; m : char);
begin
   a[r, v] := tuhik;
   vr[r, m] := true;
   vv[v, m] := true;
   vb[(r - 1) div blkr + 1, (v - 1) div blkv + 1, m] := true;
end;

{ otsib variante panna mrki kohale [r,v] }
procedure otsi(r, v : integer);
var c : char;
begin
   if r > blkm then begin
      for r := 1 to blkm do begin
         for v := 1 to blkm do
            write(a[r, v]);
         writeln;
      end;
      halt(0);                              { kui hest lahendist piisab... }
   end else if v > blkm then begin
      otsi(r + 1, 1);
   end else if a[r, v] = tuhik then begin
      for c := tmin to tmax do
         if vaba(r, v, c) then begin
            pane(r, v, c);
            otsi(r, v + 1);
            vota(r, v, c);
         end;
   end else begin
      otsi(r, v + 1);
   end;
end;

var i, j : integer; c : char;
begin
   assert(ord(tmax) - ord(tmin) + 1 = blkm);
   { algseis: kik on vabad }
   for i := 1 to blkm do
      for c := tmin to tmax do begin
         vr[i, c] := true;
         vv[i, c] := true;
      end;
   for i := 1 to blkv do
      for j := 1 to blkr do
         for c := tmin to tmax do
            vb[i, j, c] := true;
   { loeme sisendi }
   for i := 1 to blkm do begin
      for j := 1 to blkm do begin
         read(a[i, j]);
         if a[i, j] <> tuhik then
            pane(i, j, a[i, j]);
      end;
      readln;
   end;
   { alustame lahendi otsimist vasakult levalt }
   otsi(1, 1);
end.
